package question10

import (
	"testing"
)

func TestFact0(t *testing.T) {
	if Fact(0) != 1 {
		t.Fatal("Fact(0) is not 1")
	}
}

func TestFact1(t *testing.T) {
	if Fact(1) != 1 {
		t.Fatal("Fact(1) is not 1")
	}
}

func TestFactn(t *testing.T) {
	r0, r1 := 1, 1
	for i := 2; i < 15; i++ {
		r1 = Fact(i)
		t.Logf("Fact(%v) = %v", i, r1)
		if r1 != r0*i {
			t.Fatalf("Fact(%d) is wrong", i)
		}
		r0 = r1
	}
}
