package question12

func reverse(v []int) {
	for i := 0; i < len(v)/2; i++ {
		v[i], v[len(v)-i-1] = v[len(v)-i-1], v[i]
	}
}

func Next_permutation(v []int) bool {
	next := len(v) - 2
	for ; next >= 0 && v[next] > v[next+1]; next-- {
	}
	if next < 0 {
		reverse(v)
		return false
	}
	repl := next + 1
	for ; repl < len(v)-1 && v[repl+1] > v[next]; repl++ {
	}
	v[next], v[repl] = v[repl], v[next]
	reverse(v[next+1:])
	return true
}
