package question11

func merge(v1, v2 []int) (res []int) {
	i1, i2 := 0, 0
	for i1 < len(v1) && i2 < len(v2) {
		if v1[i1] < v2[i2] {
			res = append(res, v1[i1])
			i1 += 1
		} else {
			res = append(res, v2[i2])
			i2 += 1
		}
	}
	if i1 < len(v1) {
		res = append(res, v1[i1:]...)
	}
	if i2 < len(v2) {
		res = append(res, v2[i2:]...)
	}
	return
}

func Sort(v []int) []int {
	var r []int
	if len(v) < 2 {
		r = make([]int, len(v))
		copy(r, v)
	} else {
		mid := len(v) / 2
		r = merge(Sort(v[:mid]), Sort(v[mid:]))
	}
	return r
}
