package question17

type Vertex struct {
	Succ, Pred []int
}

type Graph struct {
	Order    int
	Vertices []Vertex
}

func (g *Graph) BFS_dist(src int, dist []int) {
	for i := range dist {
		dist[i] = -1
	}
	dist[src] = 0
	q := []int{src}
	for len(q) > 0 {
		v := q[0]
		q = q[1:]
		for _, s := range g.Vertices[v].Succ {
			if dist[s] == -1 {
				dist[s] = dist[v] + 1
				q = append(q, s)
			}
		}
	}
}
